/*-
 * Copyright (c) 2002  Granch Ltd. 	All rigts reserved.
 *
 * All or some portions of this file are derived from material licensed
 * to the Grahcn Ltd. and are reproduced herein with the permission of
 * Granch Ltd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE GRANCH LTD. AND THEIR CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author : Rashid N. Achilov		E-Mail shelton@granch.ru
 *
 *	$Id: make.h,v 0.93.10.1 2005/03/02 06:59:08 shelton Exp $
 */
/*--------------------------------------------------------------------------

            Standard functions library

            UNIX FreeBSD 4.8 version

            Common functions and definitions declaration

--------------------------------------------------------------------------*/
#include <config.h>

#ifdef HAVE_SYS_TYPES_H
 #include <sys/types.h>
#endif

#ifdef STDC_HEADERS
 #include <stdlib.h>
 #include <string.h>
#endif

#ifdef HAVE_LIMITS_H
 #include <limits.h>
#endif

#ifdef HAVE_SYS_CDEFS_H
 #include <sys/cdefs.h>
#endif

#ifdef HAVE_MATH_H
 #include <math.h>
#endif

#ifdef HAVE_SYSLOG_H
 #include <syslog.h>
#endif

#ifdef HAVE_STDIO_H
 #include <stdio.h>
#endif

#ifdef HAVE_FCNTL_H
 #include <fcntl.h>
#endif

#ifdef HAVE_SYS_TYPES_H
 #include <sys/types.h>
#endif

#ifdef HAVE_SYS_STAT_H
 #include <sys/stat.h>
#endif

#ifdef HAVE_UNISTD_H
 #include <unistd.h>
#endif

#ifdef HAVE_CTYPE_H
 #include <ctype.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
 #include <sys/socket.h>
#endif

#ifdef HAVE_NETINET_IN_H
 #include <netinet/in.h>
#endif

#ifdef HAVE_ARPA_INET_H
 #include <arpa/inet.h>
#endif

#ifdef HAVE_NETDB_H
 #include <netdb.h>
#endif

#ifdef HAVE_ERRNO_H
 #include <errno.h>
#endif

#ifdef HAVE_PARSECONFIG_H
 #include <parseconfig.h>
#endif

#define HZTAB	0x09
#define VTTAB	0x0B
#define SPACE	0x20
#define QUOTA	0x22
#define RETURN	0x0D
#define NEWLINE 0x0A

#define SYSLOG	1
#define PRINTF	2
					// Function descriptions
short int b_atoi(char *in,int border); 		     // Conversion to integer
int b_atol(char *in,long int border);	 	     // Conversion to long integer
u_short b_atoui(char *in,unsigned int border);	     // Conversion to unsigned integer
u_int b_atoul(char *in,unsigned long int border);    // Conversion to unsigned long integer
int atoh(char *out,char *in,int len);		     // Conversion to hex
int readconfig(char comment,char *in,char *out,int bsize);

int filecopy(char *infile,char * outfile,mode_t mode);
						 // File copying
int encode_base64(char *src, char *dest, int szdest,int srclen);
int decode_base64(char *src, char *dest, int szdest);
void replacestring(char **src,char *part1,char *part2,int *ssize);
                                                 // Replace string part by another one
int _parsedate(struct tm *ptm,char *textdata);	 // Date parsing
int _parsetime(struct tm *ptm,char *textdata);	 // Time parsing
int itoa(int num, char *str, int radix);	 // Conversion integer to string
void strunescape(char *source, char symbol);	 // Unescape line againts char
void strnunescape(char *source, char symbol,size_t len); // Unescape line againts char

char *strncasestr(register const char *s, register const char *find, size_t len);
void hexprint(char *source, size_t len, char mode); // Print character line as hex
char *__strnstr(const char *s, const char *find, size_t slen);

